/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: primsgq.h 748 2008-03-07 17:18:06Z hiro $
 */

/*
 *		ͥ٥ǡ塼ǽ
 */

#ifndef TOPPERS_PRIMSGQ_H
#define TOPPERS_PRIMSGQ_H

#include <queue.h>

/*
 *  ͥ٥ǡ֥å
 */
typedef struct primsg_management_block PMQMB;

struct primsg_management_block {
	PMQMB		*p_next;		/* Υǡ */
	intptr_t	data;			/* ǡ */
	uint_t		msgsz;			/* message size */
	PRI			datapri;		/* ǡͥ */
};

/*
 *  ͥ٥ǡ塼֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥν֥åζʬ
 *  WOBJINIBˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽΥեɤ̤ˤʤäƤ롥
 */
typedef struct primsgq_initialization_block {
	ATR			pmqatr;			/* message queue attributes */
	uint_t		pmqcnt;			/* max number of messages */
	uint_t		maxmsgsz;		/* max message size */
	PRI			maxmpri;		/* maximum priority of a message */
	PMQMB		*p_pmqmb;		/* head of the region of message blocks */
	char_t		*p_pmqbuff;		/* head of the buffer for the messages */
} PMQINIB;

/*
 *  ͥ٥ǡ塼֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥδ֥åζʬWOBJCB
 *  ĥʥ֥ȻظηѾˤΤǡǽ2Ĥ
 *  եɤ̤ˤʤäƤ롥
 *
 *  p_pmqinib: the initialization block. In particular it contains the
 *     pointer to the array of message blocks p_pmqinib->p_pmqmb
 *  count: number of message blocks in the queue at a given instant
 *  p_head: list of message blocks
 *  unused: index of the next free block in the array of message blocks
 *  p_freelist: when a message block is released it is inserted in this
 *  linked list. (Note: we could as well initialize the freelist at the
 *  beginning and we would not need the "unused" variable)
 */
typedef struct primsgq_control_block {
	QUEUE		swait_queue;	/* ͥ٥ǡ塼Ԥ塼 */
	const PMQINIB *p_pmqinib;	/* ֥åؤΥݥ */
	QUEUE		rwait_queue;	/* ͥ٥ǡ塼Ԥ塼 */
	uint_t		count;			/* ͥ٥ǡ塼Υǡο */
	PMQMB		*p_head;		/* ǽΥǡ */
	uint_t		unused;			/* ̤ѥǡ֥åƬ */
	PMQMB		*p_freelist;	/* ̤ƥǡ֥åΥꥹ */
} PMQCB;

/*
 *  ͥ٥ǡ塼Ԥ֥å
 *
 *  ι¤ΤϡƱ֥̿ȤԤ֥åζʬ
 *  WINFO_WOBJˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽ2ĤΥեɤ̤ˤʤäƤ롥
 *  ͥ٥ǡ塼ؤԤͥ٥ǡ塼μԤǡ
 *  ƱԤ֥åȤ
 */
typedef struct primsgq_waiting_information {
	WINFO		winfo;			/* ɸԤ֥å */
	PMQCB		*p_pmqcb;		/* ԤäƤͥ٥ǡ塼δ֥å*/
	intptr_t	data;			/* ǡ */
	uint_t		msgsz;			/* message size */
	PRI			datapri;		/* ǡͥ */
} WINFO_PMQ;

/*
 *  ͥ٥ǡ塼IDκ͡kernel_cfg.c
 */
extern const ID	tmax_pmqid;

/*
 *  ͥ٥ǡ塼֥åΥꥢkernel_cfg.c
 */
extern const PMQINIB	pmqinib_table[];

/*
 *  ͥ٥ǡ塼֥åΥꥢkernel_cfg.c
 */
extern PMQCB	pmqcb_table[];

/*
 *  ͥ٥ǡ塼֥åͥ٥ǡ塼IDФ
 *  Υޥ
 */
#define	PMQID(p_pmqcb)	((ID)(((p_pmqcb) - pmqcb_table) + TMIN_PMQID))

/*
 *  ͥ٥ǡ塼ǽν
 */
extern void	initialize_primsgq(void);

/*
 *  ͥ٥ǡ塼ΰؤΥǡγǼ
 */
extern void	enqueue_primsg(PMQCB *p_pmqcb, intptr_t data, uint_t msgsz, PRI datapri);

/*
 *  ͥ٥ǡ塼ΰ褫ΥǡμФ
 */
extern void	dequeue_primsg(PMQCB *p_pmqcb, intptr_t buffer, uint_t *p_msgsz, PRI *p_datapri);

/*
 *  ͥ٥ǡ塼ؤΥǡ
 */
extern bool_t	send_primsg(PMQCB *p_pmqcb, intptr_t data, uint_t msgsz,
							PRI datapri, bool_t *p_reqdsp);

/*
 *  ͥ٥ǡ塼Υǡ
 */
extern bool_t	receive_primsg(PMQCB *p_pmqcb, intptr_t buffer,
							   uint_t *p_msgsz, PRI *p_datapri,
							   bool_t *p_reqdsp);

#endif /* TOPPERS_PRIMSGQ_H */
