/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.c 264 2007-07-12 08:23:10Z hiro $
 */

/*
 *  ޥɥ饤СPB1176Tѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"

/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
	uint32_t bits;

	// clear and disable the timer interrupt
	bits = sil_rew_mem((void *)S3C_TINT_CSTAT);
	bits &= ~(0x1F << 5);
	bits |= TARGET_TIMER_INT_CLEAR;
	bits &= ~TARGET_TIMER_INT_ENABLE;
	sil_wrw_mem((void *)(S3C_TINT_CSTAT), bits);

	// set preescaler
	bits = sil_rew_mem((void *)S3C_TCFG0);
	bits &= ~TARGET_TIMER_PREESCALER_MASK;
	bits |= TARGET_PREESCALER_VALUE;
	sil_wrw_mem((void *)(S3C_TCFG0), bits);

	// set the divider
	bits = sil_rew_mem((void *)S3C_TCFG1);
	bits &= ~TARGET_TIMER_DIVIDER_MASK;
	bits |= TARGET_TIMER_DIVIDER_VALUE;
	sil_wrw_mem((void *)(S3C_TCFG1), bits);

	// set the load for 1 ms
	sil_wrw_mem((void *)(TARGET_TIMER_TCNTB), TO_CLOCK(TIC_NUME, TIC_DENO));

	// set periodic and update value
	bits = sil_rew_mem((void *)S3C_TCON);
	bits &= ~TARGET_TIMER_CONTROL_MASK;
	bits |= TARGET_TIMER_CONTROL_UPDATE;
	sil_wrw_mem((void *)(S3C_TCON), bits);
	
	// enable the timer interrupt
	bits = sil_rew_mem((void *)S3C_TINT_CSTAT);
	bits &= ~(0x1F << 5);
	bits |= TARGET_TIMER_INT_ENABLE;
	sil_wrw_mem((void *)(S3C_TINT_CSTAT), bits);

	// start the timer
	bits = sil_rew_mem((void *)S3C_TCON);
	bits &= ~TARGET_TIMER_CONTROL_MASK;
	bits |= TARGET_TIMER_CONTROL_START;
	sil_wrw_mem((void *)(S3C_TCON), bits);
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{

}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
	uint32_t bits;
	
	// clear the interrupt bit
	bits = sil_rew_mem((void *)S3C_TINT_CSTAT);
	bits &= ~(0x1F << 5);
	bits |= TARGET_TIMER_INT_CLEAR;
	sil_wrw_mem((void *)(S3C_TINT_CSTAT), bits);

	i_begin_int(INTNO_TIMER);
	signal_time();                    /* ƥåζ */
	i_end_int(INTNO_TIMER);
}
