/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: mpcore.c 791 2008-03-11 12:00:46Z honda $
 */

#include "kernel_impl.h"

/*
 * GIC CPU󥿥եϢ
 */

/*
 * CPU󥿥եν
 */
void
gic_cpu_init(void)
{
    /* ͥ٤ */
    gic_cpu_set_priority(GIC_MIN_PRIORITY);

    /* ͥ٤ӥåͭ */
    gic_cpu_set_bp(GIC_CPUIF_BPR_ALL);

    /* CPU󥿥եͭ */
    sil_wrw_mem((void *)GIC_CPUIF_CR, GIC_CPUIF_CR_EN);

    /* EOI 򥻥å */
    sil_wrw_mem((void *)GIC_CPUIF_EOI, sil_rew_mem((void *)GIC_CPUIF_IAR));
}

/*
 * CPU󥿥եνλ
 */
void
gic_cpu_stop(void)
{
    /* CPU󥿥ե̵ */
    sil_wrw_mem((void *)(GIC_CPUIF_CR), 0);
}


/*
 * GIC DIS󥿥եϢ
 */

/*
 * ߶ػ
 */
void
gic_disable_int(uint8_t id)
{
    uint16_t offset_addr;
    uint16_t offset_bit;

    offset_addr = (id / 32) * 4;
    offset_bit  = id % 32;

    sil_wrw_mem((void *)(GIC_CE + offset_addr), (1 << offset_bit));
}

/*
 * ߵ
 */
void
gic_enable_int(uint8_t id)
{
    uint16_t offset_addr;
    uint16_t offset_bit;

    offset_addr = (id / 32) * 4;
    offset_bit  = id % 32;

    sil_wrw_mem((void *)(GIC_SE + offset_addr), (1 << offset_bit));
}

/*
 * ߥڥǥ󥰥ꥢ
 */
void
gic_clear_pending(uint8_t id)
{
    uint16_t offset_addr;
    uint16_t offset_bit;

    offset_addr = (id / 32) * 4;
    offset_bit  = id % 32;

    sil_wrw_mem((void *)(GIC_CP + offset_addr), (1 << offset_bit));
}

/*
 * ߥڥǥ󥰥å
 */
void
gic_set_pending(uint8_t id){
    uint16_t offset_addr;
    uint16_t offset_bit;

    offset_addr = (id / 32) * 4;
    offset_bit  = id % 32;

    sil_wrw_mem((void *)(GIC_SP + offset_addr), (1 << offset_bit));
}

/*
 * ׵Υå
 */
bool_t
gic_probe_int(uint8_t id){
    uint32_t state;
    uint16_t offset_addr;
    uint16_t offset_bit;

    offset_addr = (id / 32) * 4;
    offset_bit  = id % 32;

    state = sil_rew_mem((void *)(GIC_SP + offset_addr));

    if((state & (1 << offset_bit)) == (1 << offset_bit)){
        return(true);
    }else{
        return(false);
    }
}

/*
 * ߥե졼
 */
void
gic_config(uint8_t id, uint8_t config){
    uint16_t offset_addr;
    uint16_t offset_bit;
    uint32_t cfgr_reg_val;

    offset_addr = (id / 16) * 4;
    offset_bit  = (id % 16) * 2;

    cfgr_reg_val  = sil_rew_mem((void *)(GIC_ICR + offset_addr));
    cfgr_reg_val &= ~(0x03U << offset_bit);
    cfgr_reg_val |= (0x03U & config) << offset_bit;

    sil_wrw_mem((void *)(GIC_ICR + offset_addr), cfgr_reg_val);
}

/*
 * ͥ٤Υå
 * ɽϤ
 */
void
gic_set_priority(uint8_t id, int pri){
    uint16_t offset_addr;
    uint16_t offset_bit;
    uint32_t pr_reg_val;

    offset_addr = (id / 4) * 4;
    offset_bit  = ((id % 4) * 8) + 4;

    pr_reg_val  = sil_rew_mem((void *)(GIC_IPR + offset_addr));
    pr_reg_val &= ~(0xfU << offset_bit);
    pr_reg_val |= (0xfU & pri) << (offset_bit);

    sil_wrw_mem((void *)(GIC_IPR + offset_addr), pr_reg_val);
}

/*
 * GICߥåȤ
 * cpusϥåȤȤCPUΥӥåȥѥǻ
 *   CPU0 : 0x01
 *   CPU1 : 0x02
 *   CPU2 : 0x04
 *   CPU3 : 0x08
 */
void
gic_set_target(uint8_t id, uint8_t cpus)
{
    uint32_t offset_addr;
    uint32_t offset_bit;
    uint32_t itr_reg_val;

    offset_addr = (id / 4) * 4;
    offset_bit  = (id % 4) * 8;

    itr_reg_val  = sil_rew_mem((void *)(GIC_ITR + offset_addr));
    itr_reg_val &= ~(0xf << offset_bit);
    itr_reg_val |= (cpus << offset_bit);


    sil_wrw_mem((void *)(GIC_ITR + offset_addr), itr_reg_val);
}

/*
 * GIC󥿥եν
 */
void
gic_init(void)
{
    int i;

    /* GIC󥿥ե̵ */
    sil_wrw_mem((void *)(GIC_CR), 0);

    /* ߤƶػ */
    for(i = 0; i < GIC_TNUM_INT/32; i++){
        sil_wrw_mem((void *)(GIC_CE + (4 * i)), 0xffffffff);
    }

    /* ڥǥ󥰤򥯥ꥢ */
    for(i = 0; i < GIC_TNUM_INT/32; i++){
        sil_wrw_mem((void *)(GIC_CP + (4 * i)), 0xffffffff);
    }

    /* ͥٺ  */
    for(i = 0; i < GIC_TNUM_INT/4; i++){
        sil_wrw_mem((void *)(GIC_IPR + (4 * i)), 0xffffffff);
    }

    /* ⡼ɽ(1-N Level) */
    for(i = 0; i < GIC_TNUM_INT/16; i++){
        sil_wrw_mem((void *)(GIC_ICR + (4 * i)), 0x55555555);
    }

    /* GIC󥿥եͭ */
    sil_wrw_mem((void *)(GIC_CR), GIC_CR_ENABLE);
}

/*
 * GIC󥿥եνλ
 */
void
gic_stop(void)
{
    /* GIC󥿥ե̵ */
    sil_wrw_mem((void *)(GIC_CR), 0);
}
